﻿Public Class Form1

    ' Größtenteils uninteressant - Hauptsächlich Animation
    ' Der Kern-Quellcode befindet sich in den anderen Quelldateien

    Private Data As Integer()

    Private ReadOnly Property DataSize() As Integer
        Get
            Return numDataSize.Value
        End Get
    End Property

    Private Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
        Dim ScalingX = PictureBox1.Width / DataSize
        Dim ScalingY = PictureBox1.Height / DataSize

        If Data Is Nothing Then Return

        For x = 0 To DataSize - 1
            e.Graphics.FillRectangle(Brushes.Red, New Rectangle(x * ScalingX, Data(x) * ScalingY, 2, 2))
        Next

    End Sub

    ' Nochmal ShellSort - zum Visualisieren
    Private Sub ShellSortVisualize(Of T)(ByVal Data() As T, ByVal Comp As Comparison(Of T), ByVal GapFunc As GapFunction)
        Dim Tmp As T
        Dim Len = Data.Length
        Dim Pos As Integer
        Dim Cols = GapFunc(Len)
        Dim Count = 0

        For Each h In Cols
            Text = "ShellSort" & " [ h = " & h.ToString & " ]"
            For i = h To Len - 1

                Tmp = Data(i)
                Pos = i

                Do Until (Pos < h) OrElse (Comp(Data(Pos - h), Tmp) > 0)
                    Data(Pos) = Data(Pos - h)
                    Pos -= h
                    If Count Mod 10 = 0 Then PictureBox1.Refresh()
                    Count += 1
                Loop
                Data(Pos) = Tmp
            Next
        Next
        PictureBox1.Refresh()
    End Sub

    Private Sub numDataSize_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numDataSize.ValueChanged
        ShuffleData()
    End Sub

    Sub ShuffleData()
        Static Rnd As New Random

        Data = (From x In Enumerable.Range(1, DataSize) Select Rnd.Next(DataSize)).ToArray

        PictureBox1.Invalidate()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cboGap.DataSource = (From x In GapSequences Select x.Name).ToList
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim [Function] = GapSequences(cboGap.SelectedIndex).Func
        Dim Comparison As Comparison(Of Integer)
        If chkAscending.Checked Then Comparison = Function(a, b) a - b Else Comparison = Function(a, b) b - a
        For Each ctl As Control In GroupBox2.Controls
            ctl.Enabled = False
        Next
        ShellSortVisualize(Data, Comparison, [Function])
        For Each ctl As Control In GroupBox2.Controls
            ctl.Enabled = True
        Next
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        ShuffleData()
    End Sub

    Private Sub cboGap_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboGap.SelectedIndexChanged
        Dim Gaps = GapSequences(cboGap.SelectedIndex).Func(100)
        Dim Str As String = ""
        For i = 0 To Gaps.Count - 2
            Str &= Gaps(i).ToString & ", "
        Next
        lblH.Text = "h = { " & Str & Gaps(Gaps.Count - 1).ToString() & " }"
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim [Function] = GapSequences(cboGap.SelectedIndex).Func
        Dim Comparison As Comparison(Of Integer)
        If chkAscending.Checked Then Comparison = Function(a, b) a - b Else Comparison = Function(a, b) b - a
        Dim Watch = New Stopwatch
        Watch.Start()
        ShellSort(Data, Comparison, [Function])
        Watch.Stop()
        MessageBox.Show(String.Format("Zeit für {0} Elemente : {1} ms", DataSize, Watch.Elapsed.TotalMilliseconds.ToString), "Ergebnis", MessageBoxButtons.OKCancel, MessageBoxIcon.Information)
        ShuffleData()
        PictureBox1.Invalidate()
    End Sub

End Class
